/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved

	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.

	This file is under Perforce control
	$Id: //depot/express/fcs992/include/avs/geomrtns.h#1 $
*/

/* Must precede geom.h to avoid conflicts */
int GOFNTN^GEOMfont_number(int);

#include <avs/geom.h>
#include <stdio.h>
#include <avs/field.h>
#include <avs/colormap.h>

/* GA - GEOM Add routines */
void GADLIN^GEOMadd_disjoint_line(GEOMobj *, Float *, Float *, int, int);
void GADPLY^GEOMadd_disjoint_polygon(GEOMobj *, Float *, Float *, Float *, int, int, int);
void GAFCOL^GEOMadd_float_colors(GEOMobj *, Float *, int, int);
void GAICOL^GEOMadd_int_colors(GEOMobj *, int *, int, int);
void GAIVAL^GEOMadd_int_value(GEOMobj *, int, int);
void GALABL^GEOMadd_label(GEOMobj *,char *,Float *,Float *,float,Float *,int);
void GANRML^GEOMadd_normals(GEOMobj *, Float *, int, int);
void GAPLIN^GEOMadd_polyline(GEOMobj *, Float *, Float *, int, int);
void GAPLY^GEOMadd_polygon(GEOMobj *, int, int *, int, int);
void GAPLYS^GEOMadd_polygons(GEOMobj *, int *, int, int);
void GAPLYH^GEOMadd_polyh(GEOMobj *, int *, int, int);
void GAPLLC^GEOMadd_polyline_colors(GEOMobj *, Float *, int, int, int);

void GAPTRI^GEOMadd_polytriangle(GEOMobj *, Float *, Float *, Float *, int, int);
void GAPTRC^GEOMadd_polytriangle_colors(GEOMobj *, Float *, int, int, int);


void GAPTRU^GEOMadd_polytriangle_uvs(GEOMobj *, Float *, int, int, int);
void GARADI^GEOMadd_radii(GEOMobj *, Float *, int, int);
void GAUVS^GEOMadd_uvs(GEOMobj *, Float *, int, int);
void GAUVWS^GEOMadd_uvws(GEOMobj *, Float *, int, int);
void GAVRT^GEOMadd_vertices(GEOMobj *, Float *, int, int);
void GAVRTD^GEOMadd_vertices_with_data(GEOMobj *, Float *, Float *, unsigned int *, int, int);
void GADPD^GEOMadd_disjoint_prim_data(GEOMobj *, int *, int, int);
void GADVD^GEOMadd_disjoint_vertex_data(GEOMobj *, int *, int, int);
void GAPLPD^GEOMadd_polyline_prim_data(GEOMobj *, int *, int, int, int);
void GAPLVD^GEOMadd_polyline_vertex_data(GEOMobj *,int *,int, int, int);
void GAPTPD^GEOMadd_polytriangle_prim_data(GEOMobj *,int *,int, int, int);
void GAPTVD^GEOMadd_polytriangle_vertex_data(GEOMobj *,int *,int, int, int);
void GAPTVT^GEOMadd_polytriangle_vertex_trans(GEOMobj *,Float *,int, int, int);
void GAPTUW^GEOMadd_polytriangle_uvws(GEOMobj *,Float *,int, int, int);
void GAPD^GEOMadd_prim_data(GEOMobj *,int *, int, int);
void GAVD^GEOMadd_vertex_data(GEOMobj *,int *,int, int);
void GAVT^GEOMadd_vertex_trans(GEOMobj *,Float *,int, int);

/* GC - GEOM Create routines */
int GCLABF^GEOMcreate_label_flags(int,int,int,int,int,int);
GEOMobj *GCMSH^GEOMcreate_mesh(Float *, Float *, int, int, int);
GEOMobj *GCMSHD^GEOMcreate_mesh_with_data(Float *, Float *, Float *, Unsigned long *, int, int, int);
void GCMUVS^GEOMcreate_mesh_uvs(GEOMobj *, double, double, double, double);
GEOMobj *GCNOBJ^GEOMcreate_normal_object(GEOMobj *, float);
GEOMobj *GCOBJ^GEOMcreate_obj(int, Float *);
GEOMobj *GCPLHD^GEOMcreate_polyh_with_data(Float *, Float *, Float *, Unsigned long *, int, int *, int, int);
GEOMobj *GCPLH^GEOMcreate_polyh(Float *, Float *, int, int *, int, int);
GEOMobj *GCSMSH^GEOMcreate_scalar_mesh(float, float, float, float, Float *, Float *, int, int, int);
GEOMobj *GSLABL^GEOMcreate_label(Float *,int);
void GCSPHU^GEOMcreate_sphere_uvs(GEOMobj *, float *, float, float, float, float);
GEOMobj *GSSPH^GEOMcreate_sphere(Float *, Float *, Float *, Float *, Unsigned long *, int, int);

/* GD - GEOM Delete routines */
void GDEDLT^GEOMdestroy_edit_list(GEOMedit_list);
void GDOBJ^GEOMdestroy_obj(GEOMobj *);
void GDUVS^GEOMdestroy_uvs(GEOMobj *);

/* GE - GEOM Edit routines */
GEOMedit_list GEINIT^GEOMinit_edit_list(GEOMedit_list);
void GECMAT^GEOMedit_concat_matrix(GEOMedit_list,char *,Float *);
void GECOL^GEOMedit_color(GEOMedit_list,char *,Float *);
void GECENT^GEOMedit_center(GEOMedit_list,char *,Float *);
void GEPOS^GEOMedit_position(GEOMedit_list,char *,Float *);
void GEFTXT^GEOMedit_field_texture(GEOMedit_list, char *, AVSfield *);
void GEGEOM^GEOMedit_geometry(GEOMedit_list,char *,GEOMobj *);
void GELITE^GEOMedit_light(GEOMedit_list,char *,char *,int);
void GEPRNT^GEOMedit_parent(GEOMedit_list,char *,char *);
void GEPROC^GEOMprocess_edit_list(GEOMedit_list);
void GEPROP^GEOMedit_properties(GEOMedit_list,char *,float,float,float,float,float,Float *);
void GERMOD^GEOMedit_render_mode(GEOMedit_list,char *,char *);
void GESMAT^GEOMedit_set_matrix(GEOMedit_list,char *,Float *);
void GEVISB^GEOMedit_visibility(GEOMedit_list,char *,int);
void GEPROJ^GEOMedit_projection(GEOMedit_list,char *,Float *);
void GESELM^GEOMedit_selection_mode(GEOMedit_list,char *,char *,int);
void GETRAM^GEOMedit_transform_mode(GEOMedit_list,char *,char *,int);
void GETEXT^GEOMedit_texture(GEOMedit_list,char *,char *);
void GETEXC^GEOMedit_texture_colormap(GEOMedit_list, char *, AVScolormap *);
void GEWIND^GEOMedit_window(GEOMedit_list,char *,Float *);
void GETOPT^GEOMedit_texture_options(GEOMedit_list,char *,int,int);
void GECLPN^GEOMedit_clip_plane(GEOMedit_list,char *,char *,int);
void GEBKFC^GEOMedit_backface(GEOMedit_list,char *,int);
void GECORT^GEOMedit_camera_orient(GEOMedit_list,char *,int,float,Float *,Float *,Float *);
void GECPRO^GEOMedit_camera_project(GEOMedit_list,char *,int,float,float,float,float);
void GEDCUE^GEOMedit_depth_cue_params(GEOMedit_list,char *,int,float,float,float);
void GESUBD^GEOMedit_subdivision(GEOMedit_list,char *,int);
void GECPRM^GEOMedit_camera_params(GEOMedit_list,char *,int,int);
void GECYCL^GEOMedit_cycle(GEOMedit_list,char *,int);

/* GG - GEOM Get routines */
int GGFNTN^GEOMget_font_number( char *, int, int );

/* GO - GEOM Other routines */
void GOFNRM^GEOMflip_normals(GEOMobj *);
void GOGNRM^GEOMgen_normals(GEOMobj *, int);
void GONNRM^GEOMnormalize_normals(GEOMobj *);
void GOUEXT^GEOMunion_extents(GEOMobj *, GEOMobj *);
void GOCKOB^GEOMcheck_obj(GEOMobj *, int, int(*)());

/* GQ - GEOM Query routines */
int GQIVAL^GEOMquery_int_value(GEOMobj *, int, int *);

/* GR - GEOM Read routines */
GEOMobj *GROBJ^GEOMread_obj(int, int);

/* GS - GEOM Set routines */
void GSCOL^GEOMset_color(GEOMobj *, unsigned long);
void GSCEXT^GEOMset_computed_extent(GEOMobj *, Float *);
void GSEXT^GEOMset_extent(GEOMobj *);
void GSOBJG^GEOMset_object_group(GEOMobj *, char *);
void GSOBJN^GEOMset_object_name(GEOMobj *, char *);
void GSPICK^GEOMset_pickable(GEOMobj *, unsigned long);

/* GT - GEOM autoTransform routines */
void GTRSFM^GEOMauto_transform(GEOMobj *);
void GTRLST^GEOMauto_transform_list(GEOMobj **, int);
void GTRNUF^GEOMauto_transform_non_uniform(GEOMobj *);
void GTRNUL^GEOMauto_transform_non_uniform_list(GEOMobj **, int);

/* GV - GEOM conVert routines */
void GVMSPT^GEOMcvt_mesh_to_polytri(GEOMobj *, int);
void GVPHPT^GEOMcvt_polyh_to_polytri(GEOMobj *, int);

/* GW - GEOM Write routines */ 
void GWOBJ^GEOMwrite_obj(GEOMobj *, int, int);
void GWTEXT^GEOMwrite_text(GEOMobj *, FILE *, int);

